/* eslint-disable no-useless-return */
import { Message, TextChannel } from 'eris';
import { Client } from '../class';

export default class {
  public client: Client;

  constructor(client: Client) {
    this.client = client;
  }

  public async run(message: Message) {
    if (message.author.bot) return;
    if (message.content.indexOf(this.client.config.prefix) !== 0) return;
    const noPrefix: string[] = message.content.slice(this.client.config.prefix.length).trim().split(/ +/g);
    const resolved = await this.client.util.resolveCommand(noPrefix);
    if (!resolved) return;
    if (resolved.cmd.guildOnly && !(message.channel instanceof TextChannel)) return;
    if (!resolved.cmd.enabled) { message.channel.createMessage(`***${this.client.util.emojis.ERROR} This command has been disabled***`); return; }
    await resolved.cmd.run(message, resolved.args);
  }
}
